const backendProtocol = "http"
const backendHost = "localhost"
const backendPort = "8161"
const backendEndpoint = "drinks"

export default class inventoryApi {
    static async save(key: string, value: any) {
        localStorage.setItem(key, JSON.stringify(value));
    }

    static async load(key: string) {
        return JSON.parse(localStorage.getItem(key) || "[]");
    }

    static async reset() {
        localStorage.removeItem("drinks")
        localStorage.removeItem("inventoryStartedAt")
        window.location.reload();
    }

    static async sendResultToBackend(inventory: any, name: string, comment: string) {
        let result = {
            inventory: inventory,
            name: name,
            comment: comment,
            inventoryFinishedAt: inventoryApi.createTimestamp()
        }

        try {
            await fetch(backendProtocol+"://"+backendHost+":"+backendPort+"/"+backendEndpoint, {
                method: "POST",
                headers: {
                    'Accept': 'application/json',
                    'Content-Type': 'application/json'
                  },
                body: JSON.stringify(result),
            })
        } catch(err) {
            console.log(err)
            alert("Ergebnis konnte nicht abgeschickt werden. Check mal die Dev-Console und/oder gib bitte kurz in der Gastro-Gruppe Bescheid...")
        }
    }

    static createTimestamp() {
        let _unixTime = Date.now();
        let _date = new Date(_unixTime).toLocaleDateString();
        let _time = new Date(_unixTime).toLocaleTimeString();

        return _date + " um " + _time
    }

    static async saveNameAndComment(name: string, comment: string) {
        let performingPerson = {
            name: name,
            comment: comment
        }

        inventoryApi.save("performingPerson", performingPerson)
    }

}
